import { Tracker } from '@formily-x/reactive';
import { getCurrentInstance, onBeforeUnmount, isVue3 } from 'vue-demi';
/* istanbul ignore next */
export var useObserver = function (options) {
    if (isVue3) {
        var vm_1 = getCurrentInstance();
        var tracker_1 = null;
        var disposeTracker_1 = function () {
            if (tracker_1) {
                tracker_1.dispose();
                tracker_1 = null;
            }
        };
        onBeforeUnmount(disposeTracker_1);
        Object.defineProperty(vm_1, 'update', {
            get: function () {
                // https://github.com/alibaba/formily/issues/2655
                return vm_1['_updateEffect'] || {};
            },
            set: function (newValue) {
                disposeTracker_1();
                var update = function () { return tracker_1 === null || tracker_1 === void 0 ? void 0 : tracker_1.track(newValue); };
                tracker_1 = new Tracker(function () {
                    if ((options === null || options === void 0 ? void 0 : options.scheduler) && typeof options.scheduler === 'function') {
                        options.scheduler(update);
                    }
                    else {
                        update();
                    }
                });
                update();
                vm_1['_updateEffect'] = newValue;
            },
        });
    }
};
//# sourceMappingURL=useObserver.js.map