"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObserver = void 0;
var reactive_1 = require("@formily-x/reactive");
var vue_demi_1 = require("vue-demi");
/* istanbul ignore next */
var useObserver = function (options) {
    if (vue_demi_1.isVue3) {
        var vm_1 = (0, vue_demi_1.getCurrentInstance)();
        var tracker_1 = null;
        var disposeTracker_1 = function () {
            if (tracker_1) {
                tracker_1.dispose();
                tracker_1 = null;
            }
        };
        (0, vue_demi_1.onBeforeUnmount)(disposeTracker_1);
        Object.defineProperty(vm_1, 'update', {
            get: function () {
                // https://github.com/alibaba/formily/issues/2655
                return vm_1['_updateEffect'] || {};
            },
            set: function (newValue) {
                disposeTracker_1();
                var update = function () { return tracker_1 === null || tracker_1 === void 0 ? void 0 : tracker_1.track(newValue); };
                tracker_1 = new reactive_1.Tracker(function () {
                    if ((options === null || options === void 0 ? void 0 : options.scheduler) && typeof options.scheduler === 'function') {
                        options.scheduler(update);
                    }
                    else {
                        update();
                    }
                });
                update();
                vm_1['_updateEffect'] = newValue;
            },
        });
    }
};
exports.useObserver = useObserver;
//# sourceMappingURL=useObserver.js.map